"use strict";
var AuthTokenHeaderMiddleware = (function () {
    function AuthTokenHeaderMiddleware() {
        var _this = this;
        this._token = null;
        this._header = 'Authorization';
        this.setToken = function (token) {
            _this._token = token;
        };
        this.setHeader = function (header) {
            _this._header = header;
        };
        this.applyMiddleware = function (request, next) {
            if (!_this._token) {
                return;
            }
            if (!request.options.headers) {
                request.options.headers = new Headers();
            }
            request.options.headers[_this._header] = _this._token;
        };
    }
    return AuthTokenHeaderMiddleware;
}());
exports.AuthTokenHeaderMiddleware = AuthTokenHeaderMiddleware;
//# sourceMappingURL=middleware.js.map